import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';

class AppUser{

  String uname;
  String name;
}


class AppConfig extends InheritedWidget {
  AppConfig({
    @required this.appid,
    @required Widget child,
  }) : super(child: child);

  final String appid;


  static AppConfig of(BuildContext context) {
    return context.inheritFromWidgetOfExactType(AppConfig);
  }

  @override
  bool updateShouldNotify(InheritedWidget oldWidget) => false;
}


class AppContext{

  static AppContext _current;
  static AppContext get current{
    return _current;
  }

  static Future<void> initialize(BuildContext ctx) async{

    if(_current == null){
      _current = AppContext();
    }

    context = ctx;
    pref = await SharedPreferences.getInstance();

  }

  static BuildContext context;
  static SharedPreferences pref;
  AppUser user;

  String _uname;
  String get uname{
    String val = pref.getString('uname');
    if(val != null){
      _uname = val;
    }
    return _uname;
  }
  set uname( String val){
    pref.setString('uname', val);
    _uname = val;
  }

  String _pwd;
  String get pwd{
    String val = pref.getString('pwd');
    if(val != null){
      _pwd = val;
    }
    return _pwd;
  }
  set pwd( String val){
    pref.setString('pwd', val);
    _pwd = val;
  }

  String get appid{
    return AppConfig.of(context).appid;
  }

}

class UserProvider{

  static UserProvider _instance;
  static UserProvider get instance{

    if(_instance == null){
      _instance = UserProvider();
    }
    return _instance;
  }


  Future<bool> validate(String uname, String pwd) async{
    AppUser u = AppUser();
    u.uname = 'c5780';
    u.name = 'Russel';
    AppContext.current.user = u;
    return Future.delayed(Duration(seconds: 2), () => true);
  }

  Future<bool> login(String uname, String pwd) async{
    AppUser u = AppUser();
    u.uname = 'c5780';
    u.name = 'Russel';
    AppContext.current.user = u;
    AppContext.current.uname = uname;
    AppContext.current.pwd = pwd;
    return Future.delayed(Duration(seconds: 2), () => true);
  }

  Future<bool> logout() async{
    AppContext.current.user = null;
    AppContext.current.uname = null;
    AppContext.current.pwd = null;
    return Future.delayed(Duration(seconds: 0), () => true);
  }

}