import 'dart:async';
import 'dart:convert';
import 'package:http/http.dart' as http;
import 'package:lkw_test_package/core.dart';


class NetworkUtil{

  static NetworkUtil _instance = NetworkUtil.internal();
  NetworkUtil.internal(){
    print('Network Util Constructor');
  }
  factory NetworkUtil() => _instance;

  final JsonDecoder _decoder = new JsonDecoder();

  Future<dynamic> post(String url, { body } ) {

    Map<String, String> headers = Map<String, String>();
    headers['appid'] = AppContext.current.appid;
    headers['uname'] = AppContext.current.uname;
    headers['pwd'] = AppContext.current.pwd;
    return http.post(
        url,
        headers: headers,
        body: body).then((http.Response response) {
      final String res = response.body;
      final int statusCode = response.statusCode;

      if (statusCode < 200 || statusCode > 400 || json == null) {
        throw new Exception("Error while fetching data");
      }
      return _decoder.convert(res);
    });
  }


}
